"use strict";
/*----------------------------------
- CONST
----------------------------------*/
exports.__esModule = true;
exports.ValueExtractor = exports.devices = exports.dataFilters = exports.bodyTypes = exports.allowedMethods = void 0;
exports.allowedMethods = ["GET", "POST"];
exports.bodyTypes = ["form", "json"];
exports.dataFilters = ["url", 'price'];
exports.devices = ['desktop', 'tablet', 'mobile'];
var ValueExtractor = /** @class */ (function () {
    function ValueExtractor(select) {
        this.options = {
            select: select
        };
    }
    ValueExtractor.prototype.attr = function (attribute) {
        this.options.attr = attribute;
        return this;
    };
    ValueExtractor.prototype.each = function (values) {
        return { $foreach: this.options.select, items: values };
    };
    ValueExtractor.prototype.filter = function (filterName) {
        if (this.options.filters === undefined)
            this.options.filters = [filterName];
        else if (this.options.filters.includes(filterName))
            throw new Error("The ".concat(this.filter, " filter has already be set for this selector."));
        else
            this.options.filters.push(filterName);
        return this;
    };
    ValueExtractor.prototype.optional = function (isOptional) {
        if (isOptional === void 0) { isOptional = true; }
        this.options.required = !isOptional;
        return this;
    };
    return ValueExtractor;
}());
exports.ValueExtractor = ValueExtractor;
